c     ****************************************************************
c     *                                                              *
c     * cdedxe:  gives -dE/dx  (gev/(g/cm2) of   e-/e+
c     *                                                              *
c
      subroutine cdedxe(aPtcl, rho, dedt)
      implicit none
#include "Zptcl.h"
#include  "ZdedxAir.h"

      real*8  rho  ! input. air density in kg/m3
      record /ptcl/ aPtcl  !  input. a Particle (e- or e+) 
      real*8  dedt ! output.  dE/dt GeV/(g/cm^2)

      real*8 emass
      real*8 E, gi, Beta2, x
      real*8 dltx, g, D, u, F, y, dlt


      real*8 bbbeta2, lindbeta2, truebeta2
      real*8 bbbeta, lindbeta
      real*8 logbbbeta, loglindbeta
      real*8 a, b, c, xx, gra
      parameter (bbbeta = 0.1d0,  lindbeta = 0.01d0, gra=4.0d0/3.d0)
      parameter (bbbeta2 = bbbeta**2, lindbeta2=lindbeta**2)
      parameter (logbbbeta =-2.302585093E+00,
     *           loglindbeta = -4.605170186E+00)
      parameter (a = (1.+gra)/2.d0/(logbbbeta-loglindbeta),
     *           b = 2*a*loglindbeta + 1.) 
c


      real*8  sha, shb
      data  sha/7.6693e-2/, shb/18.0571513/
      save   sha, shb

c       Energy, mass=emass  in MeV unit
      E =aPtcl.fm.p(4)*1000.d0
      emass = aPtcl.mass*1000.d0
      g = E/emass
      gi= 1.d0/g
      truebeta2= 1. - gi**2
      if(truebeta2 .lt. bbbeta2) then
         Beta2 = bbbeta2
         g = (1.+Beta2/2)
         E = emass*g
      else
         Beta2 = truebeta2
      endif
      call cdedxdlt(rho, g, dlt)
      u = g -1.0
c       x=log10(p/mc)
c      x=log10( (E/emass)**2 - 1. ) / 2  ! = log10(gbeta) = 0.4343log(gbeta)
      x=log10( g**2 - 1. ) / 2  ! = log10(gbeta) = 0.4343log(gbeta)
c
c        we define deltx = -delta + 4.605x = -delta + log(g+1)(g-1)
c                          -delta + log(g^2beta^2)
c
      dltx = dlt + 4.605*x
c      G formula = sh.a/Beta2* (sh.b +log(2(g+1)) + F -delta)
c     () =  sh.b + log2(g+1) + F + deltx - log(g+1)(g-1) 
c        =  sh.b + log2 + F-log(g-1) + deltx
c        =  sh.b + 0.69315 + F - log(u)
c
      if(aPtcl.charge .eq. -1) then
c          electron
         D = min(w0inMeV/emass, u/2.0)
c         original F = -1.-Beta2 +log((u-D)*D) + u/(u-D) +
c         so -logu becomes
         F = -1.-Beta2 +log((1.0-D/u)*D) + u/(u-D) +
     *        (D*D/2 +(2*g+1) * log(1.d0-D/u))/(g*g)
      else
c         positron
         D = min(w0inMeV/emass, u)
         y = 1.d0/(g+1.d0)
c         origianl F = log(uD) - D/u/u  .. so F-logu= log(D) -...
         F = log(D) - D/u/u * 
     *        ( u + 2*D - 3.0/2.0*D*D*y - (1.-D*D/3.0d0)*D*y*y
     *        -(0.5d0-u*D/3.0d0+D*D/4.0d0)*D*D*y*y*y )
      endif

c      Tupper = D*emass*1000.  ! in GeV; used in Urban.  not used
c                               in Cosmos; no Landau fluctuation

      dedt =sha/Beta2 *( shb + 0.69315 + F + dltx)


      if(truebeta2 .lt. bbbeta2) then
         c = log(dedt) + ( a* logbbbeta - b )*logbbbeta
         if( truebeta2 .gt.  lindbeta2) then
            xx = log( truebeta2 )/2.
            dedt =exp( (-a*xx + b)*xx + c)
         else
            dedt = exp( (-a*loglindbeta + b)* loglindbeta + c) *
     *             sqrt(truebeta2)/lindbeta
         endif
      endif
c///////////////
c      write(*, *) 'dedt ', 
c     * sngl(x),  sngl(dedt)
c///////////////
c          convert it to gev/(g/cm2)
       dedt=dedt *1.d-3
       end





